// automatically generated by spin2cpp v5.0.0 on Sat Apr 24 21:10:34 2021
// command line: spin2cpp --ccode QTI_simple_demo.spin 

/*  QTI_simple.spin
┌─────────────────────────────────────┬────────────────┬─────────┬────────────┐
│ QTI line sensor drver v1.0          │ BR             │ (C)2014 │  2Mar2014  │
├─────────────────────────────────────┴────────────────┴─────────┴────────────┤
│ A simple/lightweight driver object for interfacing with a "digital" QTI     │
│ line sensor.  QTI sensor has a capacitor built-in, this object determines   │
│ brightness under the sensor by charging the cap then measuring discharge    │
│ time.  Returns time in clock ticks.                                         │
│                                                                             │
│ This object tested with sparkfun "digital" QTI sensor:                      │
│  https://www.sparkfun.com/products/9454                                     │
│ Pololu.com sells a similar sensor.  Not tested with this object.            │
│                                                                             │
│ For the sensor tested (w/ 80MHz clock), the # of ticks returned varied from:│
│ • ~4000 when looking at white paper                                         │
│ • ~28000 when looking at black paper                                        │ 
│                                                                             │
│ See end of file for terms of use.                                           │
└─────────────────────────────────────────────────────────────────────────────┘

  REFERENCE CIRCUIT for connecting to QTI sensor:

         +5V ─┌───┐
    Prop pin ─│TOP├ sensor face
         GND ─└───┘  
          
 */
#include <propeller.h>
#include "qti_simple.h"

#if defined(__GNUC__)
#define INLINE__ static inline
#else
#define INLINE__ static
#ifndef __FLEXC__
#define waitcnt(n) _waitcnt(n)
#define coginit(id, code, par) _coginit((unsigned)(par)>>2, (unsigned)(code)>>2, id)
#define cognew(code, par) coginit(0x8, (code), (par))
#define cogstop(i) _cogstop(i)
#endif /* __FLEXC__ */
#endif

int32_t qti_simple_readQTI(int32_t _pin)
{
  // read QTI "digital" line senor, blocking (cog will pause for 1ms)
  qti_simple_startRC(_pin);
  waitcnt((_clkfreq / 1000) + _CNT);
  return qti_simple_readRC();
}

void qti_simple_startRC(int32_t Pin)
{
  // Start an RCtime measurement using counter A 
  // then return control to calling routine, non-blocking (no cog pause)
  // charge cap
  _DIRA |= (1 << Pin);
  _OUTA |= (1 << Pin);
  //          mode        BPIN      APIN  ' Set CTRA to "POS detector"
  // and set APIN (BPIN is ignored)
  _CTRA = ((8 << 26) + (0 << 9)) + Pin;
  // FRQA to increment phsa by 1 per clock
  _FRQA = 1;
  _PHSA = 0;
  // takes 641 ticks to execute this instruction                                     
  _DIRA &= (~(1 << Pin));
  _OUTA &= (~(1 << Pin));
}

int32_t qti_simple_readRC(void)
{
  int32_t temp = 0;
  // Retrieve RC time measurement from previous call
  // Returns -999 if counter still running (i.e. msmnt cycle not complete)
  temp = _PHSA;
  if (temp != _PHSA) {
    // check if ctra still running
    temp = -999;
  } else {
    // clear counter
    _CTRA = 0;
    _PHSA = 0;
    // subtract off 641 ticks          
    temp = temp - 641;
  }
  return temp;
}

/* 
┌────────────────────────────────────────────────────────────────────────────┐
│                              TERMS OF USE: MIT License                     │                                                            
├────────────────────────────────────────────────────────────────────────────┤
│Permission is hereby granted, free of charge, to any person obtaining a copy│ 
│of this software and associated documentation files (the "Software"), to    │
│deal in the Software without restriction, including without limitation the  │
│rights to use, copy, modify, merge, publish, distribute, sublicense, and/or │
│sell copies of the Software, and to permit persons to whom the Software is  │
│furnished to do so, subject to the following conditions:                    │
│The above copyright notice and this permission notice shall be included in  │
│all copies or substantial portions of the Software.                         │
│                                                                            │
│THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR  │
│IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,    │
│FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE │
│AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER      │
│LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING     │
│FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER         │
│DEALINGS IN THE SOFTWARE.                                                   │
└────────────────────────────────────────────────────────────────────────────┘
 */
